const {ccclass, property} = cc._decorator;
cc.macro.ENABLE_TRANSPARENT_CANVAS = true;
let  getStatus =(event)=> {
  switch (event) {
      case cc.VideoPlayer.EventType.PLAYING:
          return 'PLAYING';
      case cc.VideoPlayer.EventType.PAUSED:
          return 'PAUSED';
      case cc.VideoPlayer.EventType.STOPPED:
          return 'STOPPED';
      case cc.VideoPlayer.EventType.COMPLETED:
          return 'COMPLETED';
      case cc.VideoPlayer.EventType.META_LOADED:
          return 'META_LOADED';
      case cc.VideoPlayer.EventType.CLICKED:
          return 'CLICKED';
      case cc.VideoPlayer.EventType.READY_TO_PLAY:
          return 'READY_TO_PLAY';
      default:
          return 'NONE';
  }
}
@ccclass
export default class Video extends cc.Component {

    @property(cc.Node)
    enterScreen: cc.Node = null;

    @property(cc.Node)
    tapToContinue: cc.Node = null;
    
    @property(cc.Node)
    Games: cc.Node = null;

    @property(cc.Node)
    videoPlayer: cc.Node = null;

    @property(cc.VideoPlayer)
    video: cc.VideoPlayer = null;

    @property(cc.Button)
    overlayButton: cc.Button = null;

    @property(cc.Prefab)
    videoPlayerPrefab: cc.Prefab = null;

    @property(cc.Node)
    backBtn: cc.Node = null;
    isLoad = false;
    onLoad () {
        this.ShowTapToContinue();
    }

    start () {

    }

    ShowTapToContinue() {
        // this.video.node.on('meta-loaded', ()=>{console.log("loaded")}, this);
        cc.tween(this.tapToContinue)
          .delay(2)
          .call(() => {
            var self = this;
            this.tapToContinue.active = true;
            cc.tween(this.tapToContinue).to(0.5, { opacity: 255 }).start();
            this.overlayButton.interactable = true;
            // this.video.isFullscreen = false;
            this.instantiateVideo();
            this.videoPlayer.active = true;
            this.Games.active = false;
          })
          .start();
    }
    onStartButtonClick() {
      let testFunc = ()=>{
        this.enterScreen.active = false;
        this.tapToContinue.opacity = 0;
        this.overlayButton.interactable = false;
        this.instantiateVideo();
        this.videoPlayer.active = true;
        this.video.node.on(
          "completed",
          () => {
            // this.videoPlayer.setScale(1);
            this.video.stop();
            this.video.node.parent = null;
            this.video.node.destroy();
            this.Games.active = true;
            this.backBtn.active = true;
          },
          this
        );
        this.video.play();
      }
        if(!this.isLoad){
          return
        }else{
          this.scheduleOnce(()=>{
            testFunc();
          },0.5)
        }
    }
    instantiateVideo(){
        if(!cc.isValid(this.videoPlayer)){
            this.videoPlayer = cc.instantiate(this.videoPlayerPrefab);
            this.video = this.videoPlayer.getComponent(cc.VideoPlayer);
            this.videoPlayer.parent = cc.find("Canvas");
        }
    }
    onBackButtonClick() {
        this.backBtn.active = false;
        this.Games.active = false;
        this.enterScreen.active = true;
        this.ShowTapToContinue();
      }

      onVideoPlayerEvent (sender, event) {
        console.log('status: '+getStatus(event))
        let self = this;
        if (event === cc.VideoPlayer.EventType.CLICKED) {
            
        }else if (event === cc.VideoPlayer.EventType.READY_TO_PLAY || event === cc.VideoPlayer.EventType.META_LOADED) {
           this.isLoad = true;
        }else if (event === cc.VideoPlayer.EventType.PLAYING) {
        }
    }
    // update (dt) {}
}